#ifndef __MISC_H__
#define __MISC_H__

#define VERSION "20170705"
#define DEBUG(...) if(!dmode) {fprintf(stdout,__VA_ARGS__);fflush(stdout);}
void panic(char *msg);
#define panic(m) {perror(m); abort();}

#define BUFLEN 256

#define TYPE_SERIAL_AVR 0
#define TYPE_FILE 1
#define TYPE_TCP_AVR 2
#define TYPE_RTLSDR 3
#define TYPE_TCP_SBS3 4
#define TYPE_TCP_BEAST 5
#define TYPE_UDP_AVR 6

#define MSG_TYPE_UNKNOWN 0
#define MSG_TYPE_SHORT 1
#define MSG_TYPE_LONG 2
#define MSG_TYPE_TELEMETRY 3

#include <stdint.h>

// data source status
typedef struct {
	unsigned int packets;
	unsigned int bytes;
} source_stat;

typedef struct {
	int source_id;
	unsigned char type;
	unsigned char data[16];
	char avr_data[44];
	unsigned int data_len;
	uint32_t timestamp;
	double lat;
	double lon;
	unsigned char msg_type;
	source_stat *status;
} adsb_data;

struct list_item {
    adsb_data list_data;
    struct list_item * next;
};
typedef struct list_item item;

typedef struct {
	int port;
	void *thread_function;
	char *description;
} server_info;

void enqueue_data(adsb_data *);
unsigned int avr_data(adsb_data *, char *);
void *tcp_server(void *);

extern int dmode;

#endif
